//
// Created by webpigeon on 31/01/23.
//

#include "labs/sorting/lab1.hpp"

#include <algorithm>
#include <random>

void insertion_sort(std::vector<unsigned int>& inputs) {
    auto i = 1;
    while ( i < inputs.size() ) {
        auto j = i;
        while (j > 0 && inputs[j-1] > inputs[j]) {
            lab_swap(inputs, j, j-1);
            j--;
        }
        i++;
    }
}

void selection_sort(std::vector<unsigned int>& inputs) {
    for (auto i = 0; i < inputs.size(); ++i) {
        int min = i;

        for (int j=i; j < inputs.size(); ++j) {
            if ( inputs[j] < inputs[min] ) {
                min = j;
            }
        }

        if ( min != i) {
            lab_swap(inputs, i, min);
        }
    }
}

namespace {
    template<typename T>
    void merge_merge(std::vector<T>& A, std::size_t begin, std::size_t middle, std::size_t end, std::vector<T>& B){
        auto i = begin;
        auto j = middle;

        for ( auto k = begin; k < end; ++k ) {
            if ( i < middle && (j >= end || A[i] <= A[j])) {
                B[k] = A[i];
                i++;
            } else {
                B[k] = A[j];
                j++;
            }
        }
    }

    template<typename T>
    void merge_split(std::vector<T>& B, std::size_t begin, std::size_t end, std::vector<T>& A) {
        if ( end - begin <= 1)
            return;

        auto middle = (end + begin) / 2;
        merge_split(A, begin, middle, B);
        merge_split(A, middle, end, B);
        merge_merge(B, begin, middle, end, A);
    }
}

void merge_sort(std::vector<unsigned int>& inputs) {
    auto auxMem = inputs;
    merge_split(auxMem, 0, inputs.size(), inputs);
}
