#include "labs/trees/trees.hpp"

#include <iostream>

void add_node(Node* parent, int newValue) {
	if (parent->value > newValue) {
		if (parent->left == nullptr) {
			parent->left = new Node();
			parent->left->value = newValue;
		}
		else {
			add_node(parent->left, newValue);
		}
	}
	else {
		if (parent->right == nullptr) {
			parent->right = new Node();
			parent->right->value = newValue;
		}
		else {
			add_node(parent->right, newValue);
		}
	}
}

void print_tree(Node* root, int depth) {
	for (int i = 0; i < depth; ++i) {
		std::cout << '\t';
	}

	if (root == nullptr) {
		std::cout << "null" << std::endl;
		return;
	}

	std::cout << root->value << std::endl;
	if (!root->isLeaf()) {
		print_tree(root->left, depth + 1);
		print_tree(root->right, depth + 1);
	}
}

static void print_tree_dia_node(Node* node) {
	if (node->isLeaf()) {
		return;
	}

	if (node->left != nullptr) {
		std::cout << "\t" << node->value << " -> " << node->left->value << "[label=l];" << std::endl;
		print_tree_dia_node(node->left);
	} else {
		std::cout << "\t" << node->value << " -> l" << node->value << "[label=l];" << std::endl;
		std::cout << "\tl" << node->value << "[label=''];" << std::endl;
	}

	if (node->right != nullptr) {
		std::cout << "\t" << node->value << " -> " << node->right->value << "[label=r];" << std::endl;
		print_tree_dia_node(node->right);
	} else {
		std::cout << "\t" << node->value << " -> r" << node->value << "[label=r];" << std::endl;
		std::cout << "\tr" << node->value << "[label=N];" << std::endl;
	}
}

void print_tree_dia(Node* root) {
	std::cout << "digraph tree { " << std::endl;
	print_tree_dia_node(root);
	std::cout << "}" << std::endl;
}